import vecmath
import es

info = es.AddonInfo()
info.name = "Location bookmarker"
info.basename = "loc_bookmarker"
info.author = "GODJonez"

try:
    import syn_events
except ImportError:
    syn_events = None

playerlocations = {}

def load():
    if syn_events:
        syn_events.register('syn_player_death', syn_player_death)

def unload():
    if syn_events:
        syn_events.unregister('syn_player_death', syn_player_death)

def es_map_start(ev):
    playerlocations.clear()

def player_death(ev):
    if not syn_events:
        syn_player_death(ev)

def syn_player_death(ev):
    uid = int(ev['userid'])
    if uid:
        saveLoc(uid, '0')

def saveLoc(uid, index):
        playerlocations[uid][index] = vecmath.vector(es.getplayerlocation(uid))

def player_activate(ev):
    uid = int(ev['userid'])
    playerlocations[uid] = {}
    
def es_player_chat(ev):
    uid = int(ev['userid'])
    text = ev['text'].split(' ',1)
    if text[0] == '!go':
        if len(text) > 1:
            index = text[1]
        else:
            index = '0'
        es.server.queuecmd('es_xsetpos %d %s'%(uid, playerlocations[uid][index].getstr(' ')))
    elif text[0] == '!bm':
        if len(text) > 1:
            index = text[1]
        else:
            index = '0'
        saveLoc(uid, index)

